package
{
	// import quick box2d
	import com.actionsnippet.qbox.*;

    // other stuff
    import flash.utils.Dictionary;
	import flash.utils.getDefinitionByName;


    public class PhysicsData extends Object
	{
		// ptm ratio
        public var ptm_ratio:Number = {{global.ptm_ratio}};
		
		// the physcis data 
		var dict:Dictionary;
		
        public function createBody(name:String, sim:QuickBox2D, xPos:Number, yPos:Number):QuickObject
        {
			var fixture:Array = dict[name][0];

           	return sim.addPoly({
                        x:xPos, y:yPos, 
                        density:fixture[0], 
                        friction:fixture[1], 
                        restitution:fixture[2],
                        categoryBits: fixture[3],
                        maskBits:fixture[4],
                        groupIndex: fixture[5],
                        verts:fixture[8],
						skin:getDefinitionByName(name)
                        });							
			}
		
        public function PhysicsData(): void
		{
			dict = new Dictionary();
			
{% for body in bodies %}
			dict["{{body.name}}"] = [
{% for fixture in body.fixtures %}{% if not forloop.first %} ,{% endif %}
										[
											// density, friction, restitution
                                            {{fixture.density}}, {{fixture.friction}}, {{fixture.restitution}},
                                            // categoryBits, maskBits, groupIndex, isSensor
											{{fixture.filter_categoryBits}}, {{fixture.filter_maskBits}}, {{fixture.filter_groupIndex}}, {% if fixture.isSensor %}true{% else %}false{% endif %},
											'{{fixture.type}}',
											[
{% for polygon in fixture.polygons %}{% if not forloop.first %} ,{% endif %}
                                                [ {% for point in polygon %} {% if not forloop.first %}, {% endif %} {{point.x}}/ptm_ratio, {{point.y}}/ptm_ratio {% endfor %} ]{% endfor %}
											]
										]
{% endfor %}
									];
{% endfor %}
		}
	}
}
